unit mainf;

interface

uses
  Windows, Messages, Graphics, Controls, Forms, Dialogs, StdCtrls, ExtCtrls, ComCtrls,
  Menus,  SysUtils, Classes, IdIntercept, IdBaseComponent, IdComponent, IdTCPConnection,
  IdTCPClient, IdFTP, IdAntiFreezeBase, IdAntiFreeze, IdLogBase, IdLogDebug, IdGlobal,
  IdLogEvent, IdFTPCommon, IdFTPList, Buttons;

type
  TMainForm = class(TForm)
    IdFTP1: TIdFTP;
    UploadOpenDialog1: TOpenDialog;
    IdAntiFreeze1: TIdAntiFreeze;
    ProgressBar1: TProgressBar;
    Panel1: TPanel;
    Panel2: TPanel;
    BitBtn1: TBitBtn;
    Panel3: TPanel;
    StatusBar1: TStatusBar;
    function GetFileSize(const FileName: string): LongInt;     
    procedure IdFTP1Disconnected(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure IdFTP1Work(Sender: TObject; AWorkMode: TWorkMode;
      const AWorkCount: Integer);
    procedure IdFTP1WorkBegin(Sender: TObject; AWorkMode: TWorkMode;
      const AWorkCountMax: Integer);
    procedure IdFTP1WorkEnd(Sender: TObject; AWorkMode: TWorkMode);
    procedure DownloadAll;
    procedure ConnectServer;
    procedure FormActivate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
    AbortTransfer: Boolean;
    TransferrignData: Boolean;
    BytesToTransfer: LongWord;
    STime: TDateTime;
    procedure ChageDir(DirName: String);
    function GetHostInfo(header: String): String;
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

Uses
  IniFiles;

Var
  FS_Host : string;// Server Name
  FS_User : string;// User Id
  FS_Pswd : string;// User Password
  FS_Cdir : string;// Server Changer Dir
  CL_Cdir : string;// Local Client Dir
  FIniFileName : string; // ini file name
  AverageSpeed: Double = 0;


function TMainForm.GetFileSize(const FileName: string): LongInt;
var
 SearchRec: TSearchRec;
begin
 if FindFirst(ExpandFileName(FileName), faAnyFile, SearchRec) = 0 then
    Result := SearchRec.Size
 else Result := 0;
end;


// s Ftp Server
procedure TMainForm.ConnectServer;
begin
  with IdFTP1 do
  begin
    //  us
    BytesToTransfer := 0;
    TransferrignData := false;
    ProgressBar1.Position := 0;
    AverageSpeed := 0;
    //
    Passive  := true;
    Username := FS_User;
    Password := FS_Pswd;
    Host     := FS_Host;
    try
      Connect;
      Self.ChageDir(FS_Cdir);
    except
      showmessage('sD '+FS_Host+' ');
      application.Terminate;
    end;
  end;(*-with Idftp1.....-*)
end;

procedure TMainForm.DownloadAll;
var
  Name  : string;
  FSize : integer;
  LSize : integer;
  i    : integer;
begin
  if IdFTP1.Connected then begin
       for i := 0 to (IdFTP1.DirectoryListing.Count - 1) do
       begin
           if not (IdFTP1.DirectoryListing.Items[i].ItemType = ditDirectory) then(*-Bzؿ-*)
           begin
             Name := IdFTP1.DirectoryListing.Items[i].FileName;
             FSize := IdFTP1.DirectoryListing.Items[i].Size;
             IdFTP1.TransferType := ftBinary;
             BytesToTransfer := IdFTP1.Size(Name);
             if FileExists(CL_Cdir + '\' + Name) then begin(*-aɮצsb-*)
                LSize := GetFileSize(CL_Cdir + '\' + Name);(*-oaɮפjp-*)
                if FSize<>LSize  then begin
                   Panel3.Caption := Name;
                   IdFTP1.Get(Name, (CL_Cdir + '\' + Name),true);(*-Ƽgɮ-*)
                end;
             end(*-if FileExists...-*)
             else(*-ɮפsbتؿ-*)
             begin
                Panel3.Caption := Name;
                IdFTP1.Get(Name, (CL_Cdir + '\' + Name), false);(*-sgɮ-*)
             end;
           end;(*-if not (IdFTP1.Dir...-*)
       end;(*-for i := 0 to...-*)
  end;(*-if IdFTP1.Connected...-*)
end;


procedure TMainForm.ChageDir(DirName: String);
Var
  LS: TStringList;
begin
  LS := TStringList.Create;
  try
    IdFTP1.ChangeDir(DirName);
    IdFTP1.TransferType := ftASCII;
    IdFTP1.List(LS);
  finally
    LS.Free;
  end;
end;




procedure TMainForm.IdFTP1Disconnected(Sender: TObject);
begin
  StatusBar1.Panels[1].Text := 'wפsu.';
end;





procedure TMainForm.FormCreate(Sender: TObject);
var
  nd, mydir: string;
begin
  getdir(0, nd);
  MyDir := nd;
  if ParamCount > 0 then begin(*-o~Ѽƪini-*)
    FIniFileName := LowerCase(ParamStr(1));
    if pos('\',FIniFileName)=0 then begin
       FIniFileName := nd + '\' + FIniFileName;
    end;
    if not fileexists(FIniFileName) then begin
      showmessage('ɮ: ' + FIniFileName + ' sb!!');
      application.Terminate;
    end;
  end
  else begin
    // o P{PW ini ɮ
    FIniFileName := nd + '\' + LowerCase(ExtractFileName(Application.ExeName));
    FIniFileName := Copy(FIniFileName, 1, Length(FIniFileName) - 3) + 'ini';
  end;
  //
  MainForm.Left := 0;
  MainForm.Top := 0;
  FS_Host := GetHostInfo('FTPHOST');
  // ProgressBar A
  ProgressBar1.Parent := StatusBar1;
  ProgressBar1.Top := 2;
  ProgressBar1.Left := 0;
  ProgressBar1.Align := alClient;
  //
end;


procedure TMainForm.IdFTP1Work(Sender: TObject; AWorkMode: TWorkMode;
  const AWorkCount: Integer);
Var
  S: String;
  TotalTime: TDateTime;
  H, M, Sec, MS: Word;
  DLTime: Double;
begin
  TotalTime :=  Now - STime;
  DecodeTime(TotalTime, H, M, Sec, MS);
  Sec := Sec + M * 60 + H * 3600;
  DLTime := Sec + MS / 1000;
  if DLTime > 0 then
    AverageSpeed := {(AverageSpeed + }(AWorkCount / 1024) / DLTime{) / 2};

  if AverageSpeed > 0 then begin
    Sec := Trunc(((ProgressBar1.Max - AWorkCount) / 1024) / AverageSpeed);

    S := Format('%2d:%2d:%2d', [Sec div 3600, (Sec div 60) mod 60, Sec mod 60]);

    S := 'Ѿlɶ ' + S;
  end
  else S := '';

  S := FormatFloat('0.00 KB/s', AverageSpeed) + '; ' + S;
  case AWorkMode of
    wmRead: StatusBar1.Panels[1].Text  := 'Ut ' + S;
    wmWrite: StatusBar1.Panels[1].Text := 'Wǳt ' + S;
  end;

  if AbortTransfer then IdFTP1.Abort;

  ProgressBar1.Position := AWorkCount;
  AbortTransfer := false;
end;

procedure TMainForm.IdFTP1WorkBegin(Sender: TObject; AWorkMode: TWorkMode;
  const AWorkCountMax: Integer);
begin
  TransferrignData := true;
  AbortTransfer := false;
  STime := Now;
  if AWorkCountMax > 0 then ProgressBar1.Max := AWorkCountMax
  else ProgressBar1.Max := BytesToTransfer;
  AverageSpeed := 0;
end;

procedure TMainForm.IdFTP1WorkEnd(Sender: TObject; AWorkMode: TWorkMode);
begin
  StatusBar1.Panels[1].Text := '@~.';
  BytesToTransfer := 0;
  TransferrignData := false;
  ProgressBar1.Position := 0;
  AverageSpeed := 0;
end;


// o ini T
function TMainForm.GetHostInfo(header: String): String;
var
  ServerName: String;
  ServerIni: TIniFile;
begin
  ServerIni := TIniFile.Create(FIniFileName);
  ServerName := ServerIni.ReadString('Server', header, header);
  FS_user := ServerIni.ReadString('Server', 'FTPUSER', '1234');
  FS_Pswd := ServerIni.ReadString('Server', 'FTPPSWD', '1234');
  FS_Cdir := ServerIni.ReadString('Server', 'FTPCDIR', '/');
  CL_Cdir := ServerIni.ReadString('Client', 'DOSCDIR', 'd:\1234');

  ServerIni.Free;
  result := ServerName;
end;



procedure TMainForm.FormActivate(Sender: TObject);
begin
  ConnectServer;
  DownloadAll;
  // {
  application.Terminate;
end;

procedure TMainForm.BitBtn1Click(Sender: TObject);
begin
  if TransferrignData then
  begin
     IdFTP1.Abort;
     IdFTP1.Quit;
  end;
  application.Terminate;
end;

end.

